<template>
  <div>
    <div class="con-banner-top" />

    <div class="con-main-body">
      <div class="container">
        <div class="box-list">
          <CCard>
            <CCardHeader>
              <div>
                <font-awesome-icon :icon="['fas', 'th']" />
                <strong>Box list</strong>
              </div>
            </CCardHeader>

            <CCardBody align="center">
              <box-search-form
                @onSearch="onSearch"
              />

              <box-list
                :data="boxList"
                @checked="changeStatus"
              />
            </CCardBody>
          </CCard>
        </div>
      </div>
    </div>
  </div>
</template>

<style lang="scss" scoped>
  .box-list {
    /deep/ {
      .list {
        margin: 0 -4px;
      }
      .item {
        padding: 0 4px;
        @include mq(xxl) {
          flex: 0 0 20%;
          max-width: 20%;
        }
      }
      .card-header {
        font-weight: bold;
      }
      .list-group-item {
        position: relative;
        background: #fff;
        border: 1px solid rgba(0, 0, 21, 0.125);
        border-radius: 5px;
        padding: 6px;
        margin-bottom: 10px;
        &:hover {
          .btns-action {
            opacity: 1;
          }
        }
      }
    }
  }
</style>

<script>
import { filter } from 'lodash'
import BoxSearchForm from '~/components/organisms/boxes/BoxSearchForm'
import BoxList from '~/components/organisms/boxes/BoxList'

export default {
  components: {
    BoxSearchForm,
    BoxList
  },

  data () {
    return {
      resourceTypeName: 'box',
      boxList: [],
      boxes: []
    }
  },

  mounted () {
    this.fetch()
  },

  methods: {
    /**
     * Call API get boxes
     */
    fetch () {
      this.$dam.getBoxList()
        .then((res) => {
          if (Array.isArray(res.data) && res.data.length) {
            this.boxList = res.data
            this.boxes = res.data
          }
        })
        .catch((err) => {
          console.error(err)

          this.$toast.error(
            this.$text.error('FAILED_TO_GET', { name: 'box list' })
          )
        })
    },

    /**
     * Direct filter
     *
     * @param {Object} condition - Condition do search
     */
    onSearch (condition) {
      if (condition.name) {
        this.boxList = filter(this.boxes, function (box) { return box.name.includes(condition.name) })
      } else if (condition.status === 0 || condition.status === 1) {
        this.boxList = filter(this.boxes, function (box) { return box.status === condition.status })
      } else {
        this.fetch()
      }
    },

    /**
     * Update status box
     *
     * @param {Object} box - Item box
     */
    // TODO: Watting API send with User login
    changeStatus (box) {
      // const param = {
      //   box_id: box.id
      // }
      // this.$dam.flowBox(param)
      //   .then((res) => {
      //     if (res) {
      //       this.$toast.success(
      //         this.$text.info('UPDATED', { name: box.name })
      //       )
      //     }
      //   })
      //   .catch((err) => {
      //     console.error(err)
      //     this.$toast.error(
      //       this.$text.error('FAILED_TO_DELETE', { name: box.name })
      //     )
      //   })
    }

  }
}
</script>
